<?php

if( !defined( 'MEDIAWIKI' ) )
    die();


function line_writer($f, $c, $tmstmp, $user, $title, $is_category_of) {
    fwrite($f, $tmstmp ."\t". $user."\t".$c."\t".$title."\t". $is_category_of . "\n");
}


class RequestLogger
{

    public static function onBeforeInitialize( &$title, &$article, &$output, &$user, $request, $mediaWiki ) {
        global $wgRequestLoggerBase;

        $tmstmp = date('Y-m-d H:i:s', strtotime('+0'));
        $datefn = date('Y-m', strtotime('+0')); # risky, should use one call to date()

        $mywgLog=fopen($wgRequestLoggerBase.$datefn.".tsv", "a");
    
#    fwrite($mywgLog, "test\n");
#    fwrite($mywgLog, "title: ". $title . "\n");
        line_writer($mywgLog, 'page', $tmstmp, $user, $title, null);

#        fwrite($mywgLog, "title: ". print_r($title, true) . "\n");
        

        $dbr =& wfGetDB(DB_SLAVE);
        #select cl_to from page, categorylinks where page_id=cl_from and page_title='Тест';
        $q = $dbr -> select(["page", "categorylinks"], "cl_to", array(0=>"page_id=cl_from", "page_title"=> $title->mDbkeyform, "page_namespace"=>$title->mNamespace));
    
        if( !is_bool($q) ) {
            foreach ($q as $row) {
#                    fwrite($mywgLog, "r: ". $row->cl_to . "\n");
                line_writer($mywgLog, 'category', $tmstmp, $user, $row->cl_to, $title);
            }
        }
        fclose($mywgLog);
        return true;
    }

}